//
// DirectPlay.h
//

// Copyright Delight Delight Reduplication Development Project 1999 - 2007.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef __DirectPlay_h__
#define __DirectPlay_h__

//#ifndef DIRECTPLAY_VERSION
//#define DIRECTPLAY_VERSION 0x0300
//#endif
#include <dplay.h>
#pragma comment(lib, "dplayx.lib")

//#define INITGUID

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include <stdio.h>
#include <mmsystem.h>

#define CONNECT_SERVER	0
#define CONNECT_CLIENT	1

// DirectPlaỹbZ[W^Cv
#define SYS_DISCONNECT	0 //ڑ

#define MES_USER		100 // [U[bZ[W{l

class nsPlay {

private:

	LPDIRECTPLAY2 lpDP;
	DPID PlayerID;
	static GUID session_GUID;
	static GUID IPX_GUID;

	typedef struct tagData{
		int type;
		double data;

		int mesNo;
	}DPData;

	int iSendPac, iReceivePac; // Sent/Received Packets
	int imode; // CONNECT_SERVER or CONNECT_CLIENT
	BOOL bReady; // ڑIvC[쐬AbZ[W̑M\ԂȂTRUE
	BOOL bInit;

	DWORD dwDelay; // pPbg̕ϒx

	char SessionName[100];

	BOOL CreatePlayer(void);
	BOOL CreateGame(void);
	BOOL JoinGame(void);//int GameNo);
	BOOL ListGame(void);

	static BOOL FAR PASCAL SearchGame(LPCDPSESSIONDESC2 Session,LPDWORD TimeOut,DWORD Flag,LPVOID Context);
	static BOOL FAR PASCAL SearchService(LPGUID Guid,LPTSTR ServiceName,DWORD Version1,DWORD Version2,LPVOID None);

	char* GetError(HRESULT res);

public:

	nsPlay();
	~nsPlay();

//	GUID session_GUID;

	BOOL Init(void);//int No)
	BOOL Connect(int mode);
	void Close(void);

	BOOL WaitPlayer(void);
	BOOL Send(double data, int type, BOOL bRetry=FALSE);
	BOOL Receive(double& data,int& type);
	BOOL WaitMessage(int type,int timeout=10000);

	int GetPacketsSend   (void){ return(iSendPac);    };
	int GetPacketsReceive(void){ return(iReceivePac); };

	BOOL IsReady(void){ return(bReady); };
	int  GetMode(void){ return(imode);  };

};

#endif // #ifndef __DirectPlay_h__
