//
// 
//

// Copyright Delight Delight Reduplication Development Project 1999 - 2007.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef __structs__
#define __structs__

#include "consts.h"
#include "CMusicList.h"

#define MAX_JUKE	100 // őtH_
#define MAX_FILES	512 // őȃf[^(1tH_)
#define MAX_DEPTH	  2 // Kw

// t@C̃f[^B
typedef struct tagHeader{

	string szFile; // t@C
	string szPath; // tH_
	string szMSDFile; // MSD̃x[Xt@C

	string title;
	string artist;
	string genre;
	string msdAuthor;

	int  level[10]; //0:BMS̃x 1-9:MSD̃x(SSR Double) bms-default:3
	int  rank; // bmsՓx 0 very hard, 1 hard, 2 normal, 3 easy, ȊO ??? default:2
	int  player; // -1:MSD / 1:single 2:couple 3:double 4:versus(\)
	int  mode;	// BMS = 0:Basic 1:Another 2:SSR  MSD = 0

	int  CDTr;
	int  WavCh; // Short-WAVE ch.
	BOOL bMidi;
	BOOL bBMP;
	BOOL bPlayable;
	BOOL bWavBGM;

	int iBMLines; // 0:5line 1:7line
	int iDDRLines; // 0:4Arrow 1:6Arrow
	double dBPM; // BPM

	int iDirDepth; //tH_̉Kwڂɂ邩

	DWORD crc32[10]; // t@CCRCB܂Ńe|cache.lstɂ͕ۑȂ 0:BMS 1-9:MSDex
	DWORD filesize; // t@CTCYB܂Ńe|ňȉ

} HEADER;

struct tagJuke{

	int  iFileNum;
	string szJuke;
	HEADER* Musdat[MAX_FILES];

};

/*
struct tagKey{
	BOOL left,right,up,down,ret,ESC,shift,NUM2,NUM4,NUM5,NUM6,NUM8,NUM7,NUM9, o, ctrl, alt, F5;

	BOOL z,s,x,d,c,f,v,space,lshift;

	BOOL n,j,m,k,comma,l,dot,rshift;

	BOOL pgUp,pgDn;

	// not t@NVL[ but tL[
	BOOL f1,f2,f3,f4,f5,f6,f7,f8,f9,f0;

} key, keyo, keyp;
*/

struct tagResult{
	int perfect,great,good,boo,miss,ouch; // SetJudgeŕύX
	int maxCombo; // JudgeōXV
	int ok,ng; // AutoPlay, PlayNear, JudgeŕύX
	int comboNow; // Judge, SetJudgeŕύX

	int judgeNow,dispTime;
	BOOL isOK[10]; // OKNĜǂ`悷邩
	int dispTimeOK[10]; // ̕`掞
};

typedef	struct tagExBMP {
	// #BGAłȂ#BMPł̎w肪Ăꍇ͂-1
	// numBMSɋLqꂽl
	int num, x, y, tx, ty, ox, oy; // VBGAtH[}bg
} EXBMP;

typedef struct taObj{
	int iChannel;
// 0:IuWF
// 1:obNR[X 2:ߒZk(s͏ߐ) 3:TempoChange 4:BG-ANIME 5:ExtObj 6:PoorAnimeύX 07:BG-Layer
// Ch08̊ge|`FW͓ICh03Ƃď
// 9 : #STOPxx (DelightƎ)

// 11-17 : [BM:1P 1`5,Sc,FreeSc] [DDR:1P (,,,) = (11,13,15,16) (,_,,,^,) = (11,12,13,14,15,16)]
// 18,19 : 1P 6,7(FT)
// 21-27 : [BM:2P 1`5,Sc,FreeSc] [DDR:2P (,,,) = (21,23,25,26)]
// 28,29 : 2P 6,7(FT,̂H)

// 31-36 : BMsObj(1P) 1`5,Sc
// 41-46 : BMsObj(2P) 1`5,Sc
// 38,39 : 1P 6,7sObj
// 48,49 : 2P 6,7sObj

// Om[g̃`l1P : 5x, 2P : 6x (Rhythm-it)

	double dPixel;		// ʒu(pixelP)
	int iBar;			// ߔԍ
	double dMS;			// ʒu(msP,ݖgp)
	BOOL bJudge;
	BOOL bDraw;			// `悷邩ǂ
	BOOL bAutoPlay;
	BOOL bIsPlayed;		// tꂽ(AUTOPLAYp)
	double iBPM;		// Ch.03 or Ch.08 e|`FWp
//	int iLevel;			// ̃LcA
	int iWaveCh,iBMPCh;
	EXBMP bmp;

	double dLength;		// for V[PX~ or Om[g Ppixel
	int	iBarEnd;		// Om[g̏Iʒȕߔԍ

	int iAnime;			// Of炵&Littlep(6:4,12:8,0:ȊO)
}tagObj;

typedef struct tagMSD{
	char file[MAX_PATH];
	char title[256];
	char artist[256];
	char msdMaker[256];
	double BPM;
	int Gap;
	int level[9]; // SINGLE:0,1,2 DOUBLE:3,4,5 COUPLE:6,7,8
	int CDtrack;
	int notes[3]; // 0:1P 1:2P 2:TotalOBJ
	int endPix;
	BOOL bWavBGM;

	int iBMLines; // 0:5line 1:7line
	int iDDRLines; // 0:4Arrow 1:6Arrow

} MSD;

typedef struct tagBMS{
	int Player; // 1 SinglePlayA2 CouplePlayA3 DoublePlayA 4 BattlePlay (4̓T|[g)
	char Genre[512];
	char Title[512];
	char Artist[512];
	double BPM;
	char MIDIFile[MAX_PATH];
	int PlayLevel;	// 16܂ŁA炵B
	int Rank;		// 0 very hard, 1 hard, 2 normal, 3 easy
	int VolWAV;		// I[fBĨvpeB|I
	double Total[2];	// ȗꍇ́A 200{IuWFƌȂ܂B
	char Wav[MAX_WAVNUM][MAX_PATH];	// 01`FZ
	char BMP[256][MAX_PATH];	// 00`FF 00:MISS-BMP
	int CDtrack;	// 񂩁H
	int notes[2];
	int Obj;
	int endPix;
	char path[MAX_PATH];
	BOOL bBMP,bWavBGM,bPlayable;
	int bgBMPNum;
	DWORD endms; // Iʒu~b

	int iBMLines; // 0:5line 1:7line
	int iDDRLines; // 0:4Arrow 1:6Arrow

	BOOL bStageFile; // StageFilȇݗLƃt@C
	char stageFile[MAX_PATH];

	// YSK̗v]BBIvV "#ExpertGauge"
	int gaugeMode; // 0:Normal 1:Expert

	BOOL bUrami; // Project2DXpBMSȂTRUE

} BMS;

// XRAopɂ낢ۑ
struct tagscInfo{

	MUSIC_DATA* lpHeader;
	string fullpath; // ǂ񂾃f[^t@C̃tpX

	DWORD playtime;
	BOOL bTempoChanged; // vCɂRƂSňxłςTRUE
	BOOL bObjSkiped; // AutoplayłЂƂłPoor𖳌TRUE
	BOOL bUrami; // Project2DXpBMSȂTRUE
};

// t[YA[̏PlayNear, AutoPlay, Judgeɂ
typedef struct tagFArrow{
	double start, end; // JnAIʒu pixelP -1͖
	double fail; // ݊Oʒu pixelP
	BOOL pushed; // Jn_GreatȏTRUE
	BOOL pushNow; // ̃t[œł邩ǂB`掞ɐFς̂Ɏgp
	double nextJudge; // ɔ肷ʒu
	double nextJudgeInSTOP; // STOP̂Ŝ߂ɁASTOPPixNowÂĂƉ肵̔ʒu
} F_Arrow;

struct tagpd{
	int totalNote[2], totalObj, Gap, endPix;
	DWORD GapMS; // msPʂłGap

	double BPM, DpMS;
	int wavCh,CDTr,bgBMPNum;	// wavCh͂Ԃ0Œ
	int mode; // SINGLE+BASIĈ悤Ɏw
	BOOL bAutoPlay[2]; // AutoPlay On,Off
	int iPoorTime;
	int iPoorAnimeObj; // -1 == #BMP00 else IuWFԍ

	// ݕ\ĂBGAɑΉOBJԍ
	int iBMPObj, iBMPLayObj; // ύX
	
	BOOL bMIDI;
	int iPlayWAVCh[12];
	double dHP[2];
	double dHPRec[2][310]; // UgpHPۑ

	DWORD iScore[2]; // DDR Score InitObjSetJudgeŕύX
	double dBMScore[2]; // BM Score InitObjCalcBMScore(SetJudgeĂ΂)ŕύX

	DWORD iScoreCount[2]; // XRAJEgAbv邽߂̃JE^

	int eValu[4];
	int vol; // ̃{[BWAVVOLfp
	int volrate; // ŏ#Volwav̒lŁA㉺

	BOOL bFailed[2];
	int iPushTime[8]; // 󂪂ւގ
	int iLightTime[16]; // ڂ[ƌ鎞 2DX̔̎Ԍ˂
	int iLightCol[8];  // ̐F
	BOOL bPush; // ւłH
	double dHPInc[2]; //greatő
	double rank; // ̂
	DWORD endms; // Iʒu~b

	int tempoUP; // Ȓe|AbvBL[񐔂ɂȂĂLinearȂMusicalȂŉ
	int tempoUP2; // Ȓe|Abv(ɕςق)Bp[Zg

	DWORD stopTime; // STOPJng_lpPlayTime̒lB~ĂȂƂNOT_STOPED
	DWORD restartTime; // V[PX~畜Ag_lpPlayTime̒lB~ĂȂƂNOT_STOPED
	double oldBPM;	   // V[PX~OBPM

	// ̂ւ̓NuLbgp
	double dClubHP[2];	//ʐMHP
	BOOL bAlive[2];		//ʐM肪Ă邩

	F_Arrow f_Arrow[20]; // t[YA[BY̓`l-50

	int iBarNow, iBarNext; // ݈ʒuЂƂOAЂƂ̏ߐObjԍ

	// YSK̗v]BBIvV "#ExpertGauge"
	int gaugeMode; // 0:Normal 1:Expert

};

/*********************************************************
	ConfigNXłׂẴf[^ێ悤ɂ̂ŁA
	tagOpt\̂
	 1. ݊
	 2. mapɂނߍ
	 3. DDR.cfgɕۑKv̂Ȃf[^
	ƂRŎcĂB

	Ƃ킯Ŋ{Iɓǂݎpň悤ɁB
	ɏłDDR.cfgɂ͕ۑȂB
	ލۂConfigNX̕ցB
**********************************************************/
struct tagOpt{
	int  iAutoPlay; // 0:Disable 1:1P 2:2P 3:1P&2P
	BOOL bBgAnime; // wi
	BOOL bBMSA;
	int  iDrawMethod; //0:WaitVSYNC 1:WaitVSYNC & Sleepless 2:DirectBlt & Sleepless
	BOOL bOUCH;
	int  iHighSpeedMode; //0-4
	int  iHighSpStyle;
	BOOL bDebug;
//	BOOL bShortDA, bShortWAV; // 폜܂
	BOOL bSyncCD;
	int iEffect;
	int iCDDrNum;
	int iBlind;
	int iNArrange;
	int iLittle;
	
	int bFlat; //OfAjON,OFF
	BOOL bReverse;
	
	int iMode; //BM4,5,7orDDR4,6
	int iSoundQlty;
	int iLevel; //game level

	BOOL b1PScL; // 1PSĉƂTRUE
	BOOL b2PScL; // 2PSĉƂTRUE
	int iAutoScr;
	BOOL bUrami; // Project2DXSupport
	BOOL bIgPoor;
	int iCombo;
	BOOL bJoyPad; // WCpbhg
	BOOL bFPS; //FPS\I

	int iScCol; // ScreenColor 0:256 1:65536 2:16777216
	BOOL bFullScr;

	int iPriority; // 0:Normal 1:High
	int iBuffering; // 0:Double 1:Triple

	int iTempoChange;
	int iAutoTempoChange;
	BOOL bTCMusical;

	BOOL bUseTotal;

	// DDR.cfgɕۑȂe|ϐ
	BOOL bAllow6; // 6󃂁[h({͂GB폜
	int iCDDrMax; //CDhCu
};

struct tagDebug{
	DWORD timeNow;
	int iPixNow;
	double sumDown[2];
};

#endif
