// yaneJoyStick.h
//	 This is a JoyStick input wrapper.
//		programmed by yaneurao(M.Isozaki) '99/08/16

// Copyright yaneurao 1999 - 2007.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef __yaneJoyStick_h__
#define __yaneJoyStick_h__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#pragma comment(lib,"winmm.lib")
#include <mmsystem.h>

#include "yaneKeyBase.h"
#include "yaneWrapBase.h"

//////////////////////////////////////////////////////////////////////////////
//	ǂ̃WCXeBNgH
enum JoySelector {
	jsJOYSTICK1,
	jsJOYSTICK2,
	jsJOYSTICK1OR2	// default
};
//////////////////////////////////////////////////////////////////////////////

class CJoyStick : public CKeyBase, public CWrapBase {
	//////////////////////////////////////////////////////////////////
public:
	CJoyStick(void) { SelectJoyStick(jsJOYSTICK1OR2); } // YĂ:p

	//	from CWrapBase
	LRESULT Initialize(HWND hWnd,HINSTANCE hInst); // 
	LRESULT Terminate(void);  // I͖IɂׂI

	//	from CKeyBase
	LRESULT GetKeyState(void); // 256oCgԂǂݍ
	char*	GetKeyName(int key); // L[̖OԂ by Nickle

	//	for JoyStick setting
	void	SetButtonMax(UINT max)	{ m_nButtonMax = max;  }
	UINT	GetButtonMax(void)		{ return m_nButtonMax; }
	void	SelectJoyStick(JoySelector j) { m_joystick_selector = j; }

	//////////////////////////////////////////////////////////////////
private:
	UINT	m_uID;						//	JOYSTICK1 or JOYSTICK2
	UINT	m_nButtonMax;				//	{^ő吔(fBtHg2)

	UINT	m_uX1,m_uX2;				//	͕~l
	UINT	m_uY1,m_uY2;

	JoySelector	m_joystick_selector;	//	JOYSTICK selector

	// 𑼂̕ϐOŐ錾ƒloÔœȂƁB
	// RpC̃oOƎvcVvWFNgƍČȂB傤
	bool	m_bDIKeyAcquire;			//	AcquireێtO
	bool	m_bSuccessInit;				//	ɐ̂

};

#endif
