//	yaneVirtualKey.h :
//		Virtual Key Class for CKeyBase
//				programmed by yaneurao(M.Isozaki) '99/11/13
//

// Copyright yaneurao 1999 - 2007.
// Distributed under the Boost Software License, Version 1.0.
//    (See accompanying file LICENSE_1_0.txt or copy at
//          http://www.boost.org/LICENSE_1_0.txt)

#ifndef __yaneVirtualKey_h__
#define __yaneVirtualKey_h__

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#pragma warning(disable:4786)
#include <set>					//	STL
using namespace std;

#include "yaneKeyBase.h"

#define KEY_DEVICE_MAX	16	//	foCX̓o^\ő吔
#define VIRTUAL_KEY_MAX	150	//	zL[̍ői88:pj

class CVKeyBase {
public:
	CKeyBase*	m_lpKeyBase;
	int			m_key;
};
//	setinsert,eraseɂ͔rZq̒`Kvi_T...j
bool	operator <(const CVKeyBase& x,const CVKeyBase& y);

typedef set<CVKeyBase> CVKeyList;

class CVirtualKey {
public:
	CVirtualKey(void);
	~CVirtualKey();

	//	L[foCX̓o^
	void	ClearKeyDevice(void);					//	foCX̃NA
	void	AddDevice(CKeyBase*);					//	foCX̒ǉ
	void	RemoveDevice(CKeyBase*);				//	foCX̍폜
	void	KeyInput(void);							//@o^ĂfoCXǂ݂

	//	zL[̒ǉE폜
	void	ClearKeyList(void);						//	zL[̃Zbg
	void	AddKey(int vkey,CKeyBase*,int key);		//	zL[̒ǉ
	void	RemoveKey(int vkey,CKeyBase*,int key);	//	zL[̍폜

	bool	IsVKeyPress(int vkey);					//	zL[𒲂ׂ
	bool	IsVKeyPushDown(int vkey);				//	zL[𒲂ׂ

protected:
	int			m_nDeviceMax;						//	o^foCX
	CKeyBase*	m_lpDevice[KEY_DEVICE_MAX];			//	̓L[foCXXg
	CVKeyList	m_VKey[VIRTUAL_KEY_MAX];			//	zL[Xg
};

#endif
